/* Boghiu Marius Cristian * Grupa: 332CC
 * Materia: Proiectarea cu Microprocesoare
 *Joc :X si 0"
 */
#define F_CPU 16000000
#include <util/delay.h>
#include <stdlib.h>
#include <avr/io.h>
typedef struct pini {
	int pin;
	int port;
} PINI;

PINI verificare(int line, int col) 
{
	
	
	PINI to_ret;
	to_ret.pin=0;
	to_ret.port=0;
	
	//Red
	
	if ((line == 0) && (col == 0))
	{
		to_ret.pin = PA1;
		to_ret.port = 1;
		return to_ret;
	} 
	
	if ((line == 0) && (col == 1))  
	{
		to_ret.pin = PA3;
		to_ret.port = 1;
		return to_ret;
	}
	
	if ((line == 0) && (col == 2))  
	{
		to_ret.pin = PA5;
		to_ret.port = 1;
		return to_ret;
	}
	
	if ((line == 1) && (col == 0)) 
	{
		to_ret.pin = PA7;
		to_ret.port = 1;
		return to_ret;
	}
	
	
	if ((line == 1) && (col == 1)) 
	{
		to_ret.pin = PC6;
		to_ret.port = 3;
		return to_ret;
	}
	
	if ((line == 1) && (col == 2)) 
	{
		to_ret.pin = PC4;
		to_ret.port = 3;
		return to_ret;
	}
	
	if ((line == 2) && (col == 0)) 
	{
		to_ret.pin = PC2;
		to_ret.port = 3;
		return to_ret;
	}

	if ((line == 2) && (col == 1)) 
	{
		to_ret.pin = PC0;
		to_ret.port = 3;
		return to_ret;
	}
	
	if ((line == 2) && (col == 2))  
	{
		to_ret.pin = PD7;
		to_ret.port = 4;
		return to_ret;
	}
	
	//Green
	
	if ((line == 0) && (col == 0))
	{
		to_ret.pin = PA0;
		to_ret.port = 1;
		return to_ret;
	} 
	
	if ((line == 0) && (col == 1))
	{
		to_ret.pin = PA2;
		to_ret.port = 1;
		return to_ret;
	}
	
	if ((line == 0) && (col == 2)) 
	{
		to_ret.pin = PA4;
		to_ret.port = 1;
		return to_ret;
	}
	
	
	if ((line == 1) && (col == 0))
	{
		to_ret.pin = PA6;
		to_ret.port = 1;
		return to_ret;
	} 
	
	
	
	if ((line == 1) && (col == 1)) 
	{
		to_ret.pin = PC7;
		to_ret.port = 3;
		return to_ret;
	}
	
	
	if ((line == 1) && (col == 2)) 
	{
		to_ret.pin = PC5;
		to_ret.port = 3;
		return to_ret;
	}
	
	if ((line == 2) && (col == 0)) 
	{
		to_ret.pin = PC3;
		to_ret.port = 3;
		return to_ret;
	}
	
	if ((line == 2) && (col == 1)) 
	{
		to_ret.pin = PC1;
		to_ret.port = 3;
		return to_ret;
	}
	
	if ((line == 2) && (col == 2)) 
	{
		to_ret.pin = PD6;
		to_ret.port = 4;
		return to_ret;
	}
	
	return to_ret;
}



int main()
{
	
	
	// Setăm toti pinii portului A, B, C si D că pini de iesire
	DDRA = 0xFF;
	DDRC = 0xFF;
	DDRD = 0xFF;
	
	/* Pentru butoane test */
	

	 DDRD &= ~(1 << PD4);  // pinul PD4 va fi input
	 PORTD |= (1 << PD4);  // activam rezistenta de pull-up
	 
	 DDRD &= ~(1 << PD3);  
	 PORTD |= (1 << PD3);  
	 
	
	 DDRD &= ~(1 << PD1);  
	 PORTD |= (1 << PD1);  
	 

	 DDRD &= ~(1 << PD0);  
	 PORTD |= (1 << PD0); 
	
	 DDRD &= ~(1 << PD2);  
	 PORTD |= (1 << PD2);  
	 
	 PINI val;
	 
	 int line = 0, col = 0;

	
	 	
	 int i, j;
	int mat_led[3][3];
	
	
	 // Initializare matrice de leduri
	for (i = 0; i < 3; i++) {
		for (j = 0; j < 3; j++) {
			mat_led[i][j] = 0;
		}
	}
	
	while(1) 
	{
		line = 0;
		col = 0;
		
	
		for (i = 0; i < 3; i++) {
			for (j = 0; j < 3; j++) {
				if (mat_led[i][j] == 0)
				{
					line = i;
					col = j;
					
				}
			}
		}
		
		// Determinam pinul cu ledul liber
		val = verificare (line, col);
		
		// functie de aprinde a ledului;
		
		_delay_ms(500);
		
	}
	
	
	return 0;
}